/***************************************************************************
 *                                                                         *
 *  MAXIMUS-CBCS Source Code, Version 1.02                                 *
 *  Copyright 1989, 1990 by Scott J. Dudley.  All rights reserved.         *
 *                                                                         *
 *  Internal user editor                                                   *
 *                                                                         *
 *  For complete details of the licensing restrictions, please refer to    *
 *  the licence agreement, which is published in its entirety in MAX.C     *
 *  and LICENCE.MAX.                                                       *
 *                                                                         *
 *  USE OF THIS FILE IS SUBJECT TO THE RESTRICTIONS CONTAINED IN THE       *
 *  MAXIMUS-CBCS LICENSING AGREEMENT.  IF YOU DO NOT FIND THE TEXT OF THIS *
 *  AGREEMENT IN ANY OF THE  AFOREMENTIONED FILES, OR IF YOU DO NOT HAVE   *
 *  THESE FILES, YOU SHOULD IMMEDIATELY CONTACT THE AUTHOR AT ONE OF THE   *
 *  ADDRESSES LISTED BELOW.  IN NO EVENT SHOULD YOU PROCEED TO USE THIS    *
 *  FILE WITHOUT HAVING ACCEPTED THE TERMS OF THE MAXIMUS-CBCS LICENSING   *
 *  AGREEMENT, OR SUCH OTHER AGREEMENT AS YOU ARE ABLE TO REACH WITH THE   *
 *  AUTHOR.                                                                *
 *                                                                         *
 *  You can contact the author at one of the address listed below:         *
 *                                                                         *
 *  Scott Dudley           FidoNet  1:249/106                              *
 *  777 Downing St.        IMEXnet  89:483/202                             *
 *  Kingston, Ont.         Internet f106.n249.z1.fidonet.org               *
 *  Canada - K7M 5N3       BBS      (613) 389-8315 - HST/14.4K, 24hrs      *
 *                                                                         *
 ***************************************************************************/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <mem.h>
#include <ctype.h>
#include <io.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "prog.h"
#include "alc.h"
#include "max.h"

static struct _usr user;

/*extern int usrpriv;*/

static int userbbs,
           current_user,
           last_user,
           num_recs,
           changes,
           show_pwd;

static char *del,
            *find_name;

static int pascal MKD(void);

void pascal User_Edit(void)
{
  int cmd,
      x;

  char temp[PATHLEN],
       *p;

#ifdef AREA_EDIT
  Area_Edit();
#endif

  current_user=0;
  changes=FALSE;

  last_user=-1;

  num_recs=(int)((long)fsize(PRM(user_file))/(long)sizeof(struct _usr));

  if ((del=(char *)malloc((num_recs/CHAR_BITS)+1))==NULL ||
      (find_name=malloc(PATHLEN*sizeof(char)))==NULL)
  {
    if (del)
      free(del);
    
    logit("!No mem for delete buf");
    return;
  }
  
  *find_name='\0';
  memset(del,'\0',(num_recs/CHAR_BITS)+1);

  if ((userbbs=sopen(PRM(user_file),O_RDWR | O_BINARY,SH_DENYRW,
                     S_IREAD | S_IWRITE))==-1)
  {
    logit(cantopen,PRM(user_file));
    Printf(cantopen+1,PRM(user_file));
    Press_ENTER();
    return;
  }

  Draw_UserScreen();

  cmd='\0';

  while (cmd != 'Q')
  {
    /* If we specified an invalid user number... */

    if (last_user != current_user)
    {
      if (lseek(userbbs,(long)current_user*sizeof(struct _usr),SEEK_SET)==-1)
        Blank_User(&user);
      else
      {
        if (current_user==usernum)
          user=usr;
        else if (read(userbbs,(char *)&user,sizeof(struct _usr)) < sizeof(struct _usr))
          Blank_User(&user);
      }

      Strip_Bad_Stuff(user.name,35);
      Strip_Bad_Stuff(user.city,35);
      Strip_Bad_Stuff(user.pwd,15);
      Strip_Bad_Stuff(user.ldate,19);

      last_user=current_user;
    }

    Display_User();

    /* Keys currently used: !@#$%^&*ABCDEFGHIKLMNOPRQSTUVX+-=/;'`~: */

    Puts(WHITE);

    if (graph != GRAPHICS_none && usr.formfeed && usr.help != HOTFLASH)
      Puts("\x16\x08\x12\x01");

    cmd=Input_Char(CINPUT_prompt | CINPUT_hotflash | CINPUT_noxlt,select_p);

    if (graph != GRAPHICS_none && usr.formfeed && usr.help != HOTFLASH &&
        toupper(cmd) != 'Q')
      Puts("\x16\x08\x12\x01" CLEOL /*"\n"*/);

    switch (cmd=toupper(cmd))
    {
      case '1':
      case '2':
      case '3':
      case '4':
      case '5':
      case '6':
      case '7':
      case '8':
      case '9':
      case '0':
        if (hotkeys(usr))
          OpusGetsC(temp,cmd,"Record Number: ");
        else
        {
          strcpy(temp+1,linebuf);
          temp[0]=(char)cmd;
          mknl(linebuf);
        }

        if (*temp)
        {
          Update_User();

          last_user=current_user;

          if (atoi(temp) >= num_recs)
            current_user=num_recs-1;
          else current_user=atoi(temp);
        }
        break;

      case '=':
        show_pwd=!show_pwd;
        break;

      case '~':      /* Tilde, find user */
        UED_Find_User(TRUE);
        Putc('\n');
        Putc('\n');
        break;

      case '`':      /* Reverse quote, find NEXT user */
        UED_Find_User(FALSE);
        Putc('\n');
        Putc('\n');
        break;

      case '^':
        if (current_user==usernum)
        {
          Puts(WHITE "\nYou can't delete the current user!\n");
          Press_ENTER();

          if (usr.formfeed)
            Puts(UP CLEOL);

          if (usr.help != HOTFLASH && usr.formfeed)
            Puts(UP CLEOL UP CLEOL);
        }
        else
        {
          if (IsBit(del,current_user))
            BitOff(del,current_user);
          else BitOn(del,current_user);
        }
        break;

      case '+':
        /* To make sure that Sysop can't accidentally "+++" his modem into *
         * command mode!                                                   */

        Putc('\r');

        Update_User();

        if (++current_user >= num_recs)
          current_user=0;
        break;

      case '-':
        Update_User();

        if (current_user==0)
          current_user=num_recs-1;
        else current_user--;
        break;

      case ':':
        changes=TRUE;

        if (user.bits & BITS_hotkeys)
          user.bits &= ~BITS_hotkeys;
        else user.bits |= BITS_hotkeys;
        break;

      case '/':
        Draw_UserScreen();
        Putc('\n');
        Putc('\n');
        break;

      case '!':
        changes=TRUE;
        user.more=!user.more;
        break;

      case '#':
        changes=TRUE;
        OpusGets(temp,"Calls: ");

        if (*temp)
          user.times=atoi(temp);
        break;

      case '&':
        changes=TRUE;
        OpusGets(temp,"Nulls: ");

        if (*temp)
          user.nulls=(byte)atoi(temp);
        break;

      case '$':
        changes=TRUE;
        OpusGets(temp,"Width: ");

        if (*temp)
          user.width=(char)atoi(temp);
        break;

      case '%':
        changes=TRUE;
        OpusGets(temp,"Length: ");

        if (*temp)
          user.len=(char)atoi(temp);
        break;

      case '*':
        changes=TRUE;
        user.formfeed=!user.formfeed;
        break;

      case '\'':
        changes=TRUE;
        OpusGetsLL(temp,20,"Real name: ");

        if (*temp)
          strcpy(user.realname,temp);
        break;

      case ';':
        changes=TRUE;
        OpusGetsLL(temp,14,"Phone number: ");

        if (*temp)
          strcpy(user.phone,temp);
        break;

      case 'A':
        if (Add_User()==-1)
        {
          close(userbbs);
          return;
        }
        break;

      case 'B':
        changes=TRUE;
        user.tabs=(byte)!user.tabs;
        break;

      case 'C':
        changes=TRUE;
        OpusGetsLL(temp,35,"City: ");

        if (*temp)
          strcpy(user.city,temp);
        break;

      case 'D':
        changes=TRUE;
        OpusGets(temp,"DL, all (k-bytes): ");

        if (*temp)
          user.dnld=atoi(temp);
        break;

      case 'E':
        changes=TRUE;
        OpusGets(temp,"Debit (cents): ");

        if (*temp)
          user.debit=atoi(temp);
        break;

      case 'F':
        changes=TRUE;
        OpusGets(temp,"Last file: ");

        if (*temp)
          user.files=Set_Area_Name(temp);
        break;

      case 'X':
        changes=TRUE;
        user.use_lore=!user.use_lore;
        break;

      case 'H':
        changes=TRUE;

        cmd=KeyGetRNP("N)ovice, R)egular, E)xpert, or H)otflash? ");

        switch(toupper(cmd))
        {
          case 'N':
            user.help=NOVICE;
            break;

          case 'R':
            user.help=REGULAR;
            break;

          case 'E':
            user.help=EXPERT;
            break;

          case 'H':
            user.help=HOTFLASH;
            break;
        }
        break;

      case 'I':
        changes=TRUE;
        user.ibmchars=!user.ibmchars;
        break;

      case 'K':
        changes=TRUE;
        OpusGets(temp,"Which keys to toggle? ");

        for (p=temp;*p;p++)
        {
          if (*p >= '1' && *p <= '8')
          {
            *p -= '1';

            if (user.key & (1 << *p))
              user.key &= ~(1 << *p);
            else user.key |= (1 << *p);
          }
        }
        break;

      case 'L':
        changes=TRUE;
        OpusGets(temp,"DL, today (k-bytes): ");

        if (*temp)
          user.dnldl=atoi(temp);
        break;

      case 'M':
        changes=TRUE;
        OpusGets(temp,"Last msg: ");

        if (*temp)
          user.msg=Set_Area_Name(temp);
        break;

      case 'N':
        changes=TRUE;

        OpusGetsLL(temp,35,"User name: ");

        if (*temp)
          strcpy(user.name,fancy_str(temp));
        break;

      case 'O':
        changes=TRUE;

        cmd=KeyGetRNP("T)ty, A)nsi, or O)pus/Avatar? ");

        switch(toupper(cmd))
        {
          case 'T':
            user.avatar=0;
            user.ansi=0;
            break;

          case 'A':
            user.avatar=0;
            user.ansi=1;
            break;

          case 'O':
            user.avatar=1;
            user.ansi=0;
            break;
        }
        break;

      case 'P':
        changes=TRUE;
        OpusGetsM(temp,15,"Password: ");

        if (! *temp)
        {
          if (usr.help != HOTFLASH)
            Puts(UP CLEOL);

          if (GetyNAnswer(s(really_erase),0)==NO)
            break;
        }

        strcpy(user.pwd,temp);

        fancy_str(user.pwd);
        break;

      case 'Q':
        Update_User();
        break;

      case 'R':
        changes=TRUE;
        OpusGets(temp,"Credit (cents): ");

        if (*temp)
          user.credit=atoi(temp);
        break;

      case 'S':
        changes=TRUE;
        user.kludge=!user.kludge;
        break;

      case 'T':
        changes=TRUE;
        OpusGets(temp,"Time: ");

        if (*temp)
          user.time=atoi(temp);
        break;

      case 'U':
        changes=TRUE;
        OpusGets(temp,"UL (K-bytes): ");

        if (*temp)
          user.upld=atoi(temp);
        break;

      case 'V':
        changes=TRUE;

        if (isnl(linebuf))
        {
          if (usr.help==HOTFLASH)
            Puts("\n\n");

          Puts("H)idden, S)ysop, A)sstSysop, C)lerk, E)xtra, F)avored, P)rivil, W)orthy,\n"
               "N)ormal, L)imited, D)isgrace, T)wit\n\n");
        }

        cmd=KeyGetRNP(select_p);

        if (graph != GRAPHICS_none && usr.formfeed)
          Puts("\x16\x08\x12\x01" CLEOL "\n" CLEOL "\n" CLEOL "\n" CLEOL "\n" CLEOL);

        for (x=0;x < _PRIVS_NUM;x++)
          if (toupper(cmd)==*_privs[x].name)
          {
            user.priv=_privs[x].priv;
            break;
          }
        break;

      case '?':
        if (usr.help==HOTFLASH)
          Puts("\n\n");

        Puts(YELLOW "/" GRAY ") Redraw Screen    " YELLOW "=" GRAY ") Toggle pwd display        " YELLOW "A" GRAY ") Add a user\n"
             YELLOW "~" GRAY ") Find a user      " YELLOW "`" GRAY ") Find next search match    " YELLOW "^" GRAY ") Del/Undel user\n"
             YELLOW "+" GRAY ") Display NEXT usr " YELLOW "-" GRAY ") Display PRIOR user        " YELLOW "Q" GRAY ") Quit\n"
                    "   or type rec.num to jump to specific user.\n" WHITE);
        Press_ENTER();

        if (graph != GRAPHICS_none && usr.formfeed)
        {
          if (usr.help != HOTFLASH)
            Puts(UP);

          Puts(UP UP UP UP CLEOL "\n" CLEOL "\n" CLEOL "\n" CLEOL);

          if (usr.help != HOTFLASH)
            Puts("\n" CLEOL);
        }

        break;

      case '\x0d':
      case '\x00':
      case '|':
        break;
    }

    if (usr.help != HOTFLASH && usr.formfeed && isnl(linebuf))
      Puts(UP CLEOL "\n" CLEOL);
  }

  close(userbbs);
  Purge_Users();

  free(find_name);
  free(del);
}


void pascal Draw_UserScreen(void)
{
  if (graph != GRAPHICS_none && usr.formfeed)
  {
    Printf(CLS GRAY "  user number      /%d\n\n",num_recs-1);

    Puts("    user " YELLOW "N" GRAY "ame\n");
    Puts("         " YELLOW "C" GRAY "ity\n");
    Puts("     " YELLOW "P" GRAY "assword\n");
    Puts(YELLOW ";" GRAY "phone number                " "     "   YELLOW "'" GRAY "real name\n");
    Puts(GRAY "   pri" YELLOW "V" GRAY " level                " "   " YELLOW "T" GRAY "ime on-line              " "   " YELLOW "#" GRAY " of calls\n");
    Puts("      " YELLOW "U" GRAY "ploads      K         "  "       "  YELLOW "D" GRAY "l (all)      K       " "   "  "d" YELLOW "L" GRAY " (today)       K\n\n");

    Puts(GRAY "last " YELLOW "M" GRAY "sg.area                " " "  "last " YELLOW "F" GRAY "ile area                   " YELLOW ":" GRAY "hotkeys\n");
    Puts(GRAY "       c" YELLOW "R" GRAY "edit       cents    " "          " "d" YELLOW "E" GRAY "bit       cents\n\n");

    Puts("   " YELLOW "H" GRAY "elp level                " "           " "ta" YELLOW "B" GRAY "s              " "       " YELLOW "&" GRAY "nulls\n");
    Puts("    " YELLOW "I" GRAY "bm chars                " "     " "vide" YELLOW "O" GRAY " mode              " "        " "ma" YELLOW "X" GRAY "ed\n");
    Puts(" " YELLOW "!" GRAY "more prompt                " "   " "u" YELLOW "S" GRAY "ed maximus              " "  " YELLOW "*" GRAY "scrn.clear\n");
    Puts("         " YELLOW "K" GRAY "eys                " "    " YELLOW "$" GRAY "scrn.width              " "  " YELLOW "%" GRAY "scrn.lngth\n");
  }
}



void pascal Display_User(void)
{
  char pwd[17];
  
  if (graph != GRAPHICS_none && usr.formfeed)
  {
    Printf(CYAN "\x16\x08\x01\x0f%5d\x16\x08\x01\x1b%s\x16\x08\x01\x2c%s%s%s",
            current_user,
            current_user==usernum ? s(ued_curu) : cleol,
            IsBit(del,current_user) ? s(ued_delu) : cleol,
            (user.flag & UFLAG_deleted) ? s(ued_du) : cleol,
            (user.flag & UFLAG_permanent) ? s(ued_pu) : cleol);

    if (MKD())
      goto Dump;

    Printf(CYAN "\x16\x08\x03\x0f%s" GRAY CLEOL "\x16\x08\x03\x39%s" CYAN,user.name,*user.ldate==' ' ? user.ldate+1 : user.ldate);

    if (MKD())
      goto Dump;

    Printf("\x16\x08\x04\x0f%s" CLEOL,user.city);

    if (MKD())
      goto Dump;

    Printf("\x16\x08\x05\x0f%-15s",Show_Pwd(user.pwd,pwd));

    if (MKD())
      goto Dump;

    Printf("\x16\x08\x06\x0f%-14s",user.phone);

    if (MKD())
      goto Dump;

    Printf("\x16\x08\x06\x2e%s" CLEOL,user.realname);

    if (MKD())
      goto Dump;

    Printf("\x16\x08\x07\x0f%-9s",Priv_Level(user.priv));

    if (MKD())
      goto Dump;

    Printf("\x16\x08\x07\x2e%-5u",user.time);

    if (MKD())
      goto Dump;

    Printf("\x16\x08\x07\x49%-5u",user.times);

    if (MKD())
      goto Dump;

    Printf("\x16\x08\x08\x0f%5u",user.upld);

    if (MKD())
      goto Dump;

    Printf("\x16\x08\x08\x2e%5u",user.dnld);

    if (MKD())
      goto Dump;

    Printf("\x16\x08\x08\x49%5u",user.dnldl);

    if (MKD())
      goto Dump;

    Printf("\x16\x08\x0a\x0f%-2.2s",Area_Name(user.msg));

    if (MKD())
      goto Dump;

    Printf("\x16\x08\x0a\x2e%-2.2s",Area_Name(user.files));

    if (MKD())
      goto Dump;

    Printf("\x16\x08\x0a\x49%-3s",Yes_or_No(user.bits & BITS_hotkeys));

    if (MKD())
      goto Dump;

    Printf("\x16\x08\x0b\x0f%5u",user.credit);

    if (MKD())
      goto Dump;

    Printf("\x16\x08\x0b\x2e%5u",user.debit);

    if (MKD())
      goto Dump;

    Printf("\x16\x08\x0d\x0f%-8s",Help_Level(user.help));

    if (MKD())
      goto Dump;

    Printf("\x16\x08\x0d\x2e%-3s",Yes_or_No(user.tabs));

    if (MKD())
      goto Dump;

    Printf("\x16\x08\x0d\x49%-5d",user.nulls);

    if (MKD())
      goto Dump;

    Printf("\x16\x08\x0e\x0f%-3s",Yes_or_No(user.ibmchars));

    if (MKD())
      goto Dump;

    Printf("\x16\x08\x0e\x2e%-6.6s",(user.avatar ? s_avatar : (user.ansi ? s_ansi : s_tty)));

    if (MKD())
      goto Dump;

    Printf("\x16\x08\x0e\x49%-3s",Yes_or_No(user.use_lore==0));

    if (MKD())
      goto Dump;

    Printf("\x16\x08\x0f\x0f%-3s",Yes_or_No(user.more));

    if (MKD())
      goto Dump;

    Printf("\x16\x08\x0f\x2e%-3s",Yes_or_No(user.kludge));

    if (MKD())
      goto Dump;

    Printf("\x16\x08\x0f\x49%-3s",Yes_or_No(user.formfeed));

    if (MKD())
      goto Dump;

    Printf("\x16\x08\x10\x0f%-8.8s",Keys(user.key));

    if (MKD())
      goto Dump;

    Printf("\x16\x08\x10\x2e%-5d",user.width);

    if (MKD())
      goto Dump;

    Printf("\x16\x08\x10\x49%-5d",user.len);
    return;

  Dump:

    Puts("\x16\x08\x10\x4e");
    mdm_dump(DUMP_output);
    return;
  }
  else
  {
    Printf(CLS GRAY "  user number %5d/%d %s%s%s%s\n\n",
           current_user,
           num_recs-1,
           current_user==usernum ? s(ued_curu) : cleol,
           IsBit(del,current_user) ? s(ued_delu) : cleol,
           (user.flag & UFLAG_deleted) ? s(ued_du) : cleol,
           (user.flag & UFLAG_permanent) ? s(ued_pu) : cleol);

    Printf(GRAY "    user " YELLOW "N" GRAY "ame " CYAN "%-35s " GRAY "%s\n" CYAN,
           user.name,*user.ldate==' ' ? user.ldate+1 : user.ldate);

    Printf(YELLOW "         C" GRAY "ity " CYAN "%s\n",user.city);

    Printf(YELLOW "     P" GRAY "assword " CYAN "%s\n",
           Show_Pwd(user.pwd,pwd));

    Printf(YELLOW ";" GRAY "phone number " CYAN "%-14s " YELLOW "     '" GRAY "real name " CYAN "%s\n",
           user.phone,user.realname);

    Printf(GRAY "   pri" YELLOW "V" GRAY " level " CYAN "%-10s     " YELLOW "   T" GRAY "ime on-line " CYAN "%-5u        " YELLOW "   #" GRAY " of calls " CYAN "%u\n",
           Priv_Level(user.priv),user.time,user.times);

    Printf(YELLOW "      U" GRAY "ploads " CYAN "%5uK         " YELLOW "       D" GRAY "l (all) " CYAN "%5uK       " GRAY "   d" YELLOW "L " GRAY "(today) " CYAN "%5uK\n\n",
           user.upld,user.dnld,user.dnldl);

    Printf(GRAY "last " YELLOW "M" GRAY "sg.area " CYAN "%-2s             " GRAY " last " YELLOW "F" GRAY "ile area " CYAN "%-2s                " YELLOW ":" GRAY "hotkeys " CYAN "%s\n",
           Area_Name(user.msg),Area_Name(user.files),
           Yes_or_No(user.bits & BITS_hotkeys));

    Printf(GRAY "       c" YELLOW "R" GRAY "edit " CYAN "%5u " GRAY "cents              d" YELLOW "E" GRAY "bit " CYAN "%5u " GRAY "cents\n\n",
           user.credit,user.debit);

    Printf(YELLOW "   H" GRAY "elp level " CYAN "%-9s      " GRAY "           ta" YELLOW "B" GRAY "s " CYAN "%-3s          " YELLOW "       &" GRAY "nulls " CYAN "%d\n",
           Help_Level(user.help),Yes_or_No(user.tabs),user.nulls);

    Printf(YELLOW "    I" GRAY "bm chars " CYAN "%-3s            " GRAY "     vide" YELLOW "O" GRAY " mode " CYAN "%-6s       " GRAY "        ma" YELLOW "X" GRAY "ed " CYAN "%s\n",
           Yes_or_No(user.ibmchars),
           (user.avatar ? s_avatar : (user.ansi ? s_ansi : s_tty)),
           Yes_or_No(user.use_lore==0));

    Printf(YELLOW " !" GRAY "more prompt " CYAN "%-3s            " GRAY "   u" YELLOW "S" GRAY "ed maximus " CYAN "%-3s          " YELLOW "  *" GRAY "scrn.clear " CYAN "%s\n",
           Yes_or_No(user.more),Yes_or_No(user.kludge),
           Yes_or_No(user.formfeed));

    Printf(YELLOW "         K" GRAY "eys " CYAN "%-8s       " YELLOW "    $" GRAY "scrn.width " CYAN "%-5d        " YELLOW "  %%" GRAY "scrn.lngth " CYAN "%d\n",
           Keys(user.key),user.width,user.len);
  }
}


void pascal Purge_Users(void)
{
  FFIND *ff;

  int x,
      recn,
      userbbs,
      outfile,
      lrfile,
      ret,
      zero;

  struct _usr user;
  struct _area area;

  char temp[PATHLEN];

  int purgelr[200],
      pn;

  for (x=0;x < num_recs;x++)
    if (IsBit(del,x))
      break;

  if (x != num_recs)    /* If there's something to be deleted */
  {
    sprintf(temp,active_star,original_path);

    for (ff=FindOpen(temp,0),ret=0;ff && ret==0;ret=FindNext(ff))
    {
      if (sscanf(ff->ff_name,active_x_bbs,&x) != 1)
        x=0;

      if (x != task_num)
      {
        Printf(WHITE "\n\nError!  Task %02x is still active.  All active tasks must be\n"
               "terminated before Max can do a user purge.  If task %02x was terminated\n"
               "prematurely, then you must delete the file called\n"
               "%sACTIVE%02x.BBS to tell Max that task %02x is no longer active.\n\n",
               x,x,original_path,x,x);

        Press_ENTER();
        FindClose(ff);
        return;
      }
    }

    FindClose(ff);

    if ((userbbs=sopen(PRM(user_file),O_RDWR | O_BINARY,SH_DENYRW,S_IREAD | S_IWRITE))==-1)
    {
      logit(cantopen,PRM(user_file));
      return;
    }

    Puts(CLS WHITE "Purging users:\n\n");

    if ((outfile=sopen(user_poo,O_CREAT | O_TRUNC | O_WRONLY | O_BINARY,SH_DENYRW,S_IREAD | S_IWRITE))==-1)
    {
      logit(cantopen,user_poo);
      close(userbbs);
      return;
    }

    for (x=recn=pn=0;x < num_recs;x++)
    {
      if (read(userbbs,(char *)&user,sizeof(struct _usr)) != sizeof(struct _usr))
      {
        logit(cantread,PRM(user_file));
        break;
      }

      Strip_Bad_Stuff(user.name,35);

      if (IsBit(del,x) && (usernum != x || usernum==-1) && pn < 200)
      {
        Printf(YELLOW "Deleted: " GRAY "%s\n",user.name);
        purgelr[pn++]=user.lastread_ptr;
      }
      else
      {
        if (write(outfile,(char *)&user,sizeof(struct _usr)) != sizeof(struct _usr))
        {
          logit(cantwrite,user_poo);
          close(outfile);
          close(userbbs);
          unlink(user_poo);
          return;
        }

        /* Adjust our user number, in case the purge has changed our        *
         * position.                                                        */

        if (usernum==x)
          usernum=recn;

        recn++;
      }
    }

    close(outfile);
    close(userbbs);

    if (fexist(user_bak))
      unlink(user_bak);

    if (! move_file(PRM(user_file),user_bak)==0)
      logit(cantmove,PRM(user_file),user_bak);
    else if (! move_file(user_poo,PRM(user_file))==0)
      logit(cantmove,user_poo,PRM(user_file));
    else
    {
      Puts(YELLOW "\nCleansing lastread pointers:\n");

      zero=0;
      lseek(areasfile,0L,SEEK_SET);

      while (read(areasfile,(char *)&area,sizeof(struct _area))==sizeof(struct _area))
      {
        if (*area.msgpath)
        {
          Printf("  %s\n",fancy_str(area.msgpath));

          sprintf(temp,ps_lastread,area.msgpath);

          if ((lrfile=shopen(temp,O_RDWR | O_BINARY)) != -1)
          {
            for (x=0;x < pn;x++)
            {
              lseek(lrfile,(long)purgelr[x]*sizeof(int),SEEK_SET);
              write(lrfile,(char *)&zero,sizeof(int));
            }

            close(lrfile);
          }
        }
      }
    }

    Puts("\nDone!\n");
  }
}


void pascal Strip_Bad_Stuff(char *s,int m)
{
  *(s+m)='\0';

  while (*s)
  {
    if (*s < 32 || *s > 127)
      *s=' ';

    s++;
  }
}


void pascal Update_User(void)
{
  if (changes)
  {
    lseek(userbbs,(long)current_user*sizeof(struct _usr),SEEK_SET);
    write(userbbs,(char *)&user,sizeof(struct _usr));

    changes=FALSE;
  }

  if (current_user==usernum)
  {
    if (usr.priv != user.priv)
    {
      usr=user;
      Find_Class_Number();
    }
    else usr=user;

    /*usrpriv=usr.priv;*/
  }
}


int pascal Add_User(void)
{
  Update_User();

  current_user=num_recs;
  last_user=current_user;

  num_recs++;

  if ((del=(char *)realloc(del,(num_recs/CHAR_BITS)+1))==NULL)
    return -1;

  del[num_recs/CHAR_BITS]='\x00';

  Blank_User(&user);
  user.lastread_ptr=Find_Next_Lastread();

  changes=TRUE;
  Update_User();

  Draw_UserScreen();
  return 0;
}


int pascal Find_Next_Lastread(void)
{
  int unum,
      ret,
      x,y;

  struct _usr *user;

  lseek(userbbs,0L,SEEK_SET);

  if ((user=malloc(sizeof(struct _usr)*USR_SEARCH))==NULL)
  {
    logit(mem_nubuf);
    return 0;
  }

  FindLR_Start();

  for (unum=0;! eof(userbbs);unum += y)
  {
    /* Read the user records in big blocks, for efficiency */

    y=read(userbbs,(char *)user,sizeof(struct _usr)*USR_SEARCH) / sizeof(struct _usr);

    /* Now loop through the records we read in, and look for a match */

    for (x=0;x < y;x++)
      FindLR_AddOne(user[x].lastread_ptr,unum+x);
  }

  ret=FindLR_GetFreePtr();
  FindLR_Stop();
  free(user);

  return ret;
}


char * pascal Show_Pwd(char *pwd,char *ret)
{
  char *s,
       *p;

  if (show_pwd)
    return pwd;
  else
  {
    for (s=pwd,p=ret;*s;s++,p++)
      *p='.';

    *p='\0';

    return ret;
  }
}


void pascal UED_Find_User(int begin)
{
  struct _usr u;
  int x;

  if (begin)
    OpusGetsLL(find_name,PATHLEN-1,"Type the name of the user you wish to find: ");

  if (*find_name)
  {
    Update_User();

    if (begin)
      lseek(userbbs,0L,SEEK_SET);

    while ((x=read(userbbs,(char *)&u,sizeof(struct _usr))) > 0)
      if (stristr(u.name,find_name))
      {
        current_user=(int)(tell(userbbs)/(long)sizeof(struct _usr))-1;
        break;
      }

    if (x <= 0)
    {
      Puts(WHITE "\n\nNot found.\n");
      Press_ENTER();

      if (usr.help==HOTFLASH && usr.formfeed)
        Puts(UP UP CLEOL "\n" CLEOL);

      if (usr.help != HOTFLASH && usr.formfeed)
        Puts(UP UP UP UP UP CLEOL "\n" CLEOL "\n" CLEOL "\n" CLEOL "\n" CLEOL);
    }
  }

  if (usr.formfeed)
    Puts(UP CLEOL);
}

static int pascal MKD(void)
{
  if (Mdm_keyp() && hotkeys(usr))
    return TRUE;
  else return FALSE;
}


#ifdef AREA_EDIT

void pascal Draw_Area_Screen(void);
void pascal Display_Area_Menu(void);
void pascal Draw_Area(void);

static struct _area ar;

void pascal Area_Edit(void)
{
  int ch;

  if (graph==GRAPHICS_none)
  {
    Puts("The area editor requires ANSI or AVATAR graphics.\n");
    Press_ENTER();
    return;
  }

  Read_Area(&ar,Set_Area_Name("1"));

  Draw_Area_Screen();
  Draw_Area();

  for (ch=0;ch != 'Q';)
  {
    Puts(WHITE "\x16\x08\x13\x03");
    Puts("A)ttribute       M)essage Section  F)ile Section     G)lobal Info");

    Puts(WHITE "\x16\x08\x14\x03");
    Puts("+)next area      -)prior area      C)hange Area      Q)uit\n");

    switch(ch=Mdm_getcw())
    {
      case 'Q':
        break;
    }
  }
}


void pascal Draw_Area_Screen(void)
{
  Puts(CLS LGREEN "\x19\x4d"
                  "\x16\x19\x05" DOWN LEFT "\x13\n"
                  "\x19\x4d\r" RIGHT
                  "\x16\x19\x05" UP LEFT "\x13\n");

  Puts("\x16\x08\x02\x03" YELLOW "Area:                                 Attribute:\n");

  Puts(LGREEN "\x19\x4d");

  Puts(LBLUE "\x16\x08\x05\x03""Msg Description:" LCYAN);

  Puts("\x16\x08\x08\x03""Msg.Area Priv:");
  Puts("\x16\x08\x09\x03""Message Path:");
  Puts("\x16\x08\x0a\x03""EchoMail Tag:");
  Puts("\x16\x08\x0b\x03""Msg Barricade:");
  Puts("\x16\x08\x0c\x03""Origin AKA:");
  Puts("\x16\x08\x0d\x03""Origin Line:");

  Puts(LBLUE "\x16\x08\x06\x03""File Description:" LMAGENTA);

  Puts("\x16\x08\x08\x29""File Area Priv:");
  Puts("\x16\x08\x09\x29""Download Path:");
  Puts("\x16\x08\x0a\x29""Upload Path:");
  Puts("\x16\x08\x0b\x29""File Barricade:");
  Puts("\x16\x08\x0c\x29""FILES.BBS equiv:");

  Puts(YELLOW "\x16\x08\x0f\x03""Menu Path:");

  Puts(LGREEN "\x19\x4d");
}

void pascal Draw_Area(void)
{
  Puts(WHITE);

  Printf("\x16\x08\x02\x09%s",ar.name);
  Printf("\x16\x08\x02\x34%s",ar.attrib);




  Printf("\x16\x08\x05\x15%s",ar.msginfo);

  Printf("\x16\x08\x08\x12%s%s%s",
         Priv_Level(ar.msgpriv),
         ar.msglock ? "/" : blank_str,
         ar.msglock ? Keys(ar.msglock) : blank_str);

  Printf("\x16\x08\x09\x12%-23.23s",ar.msgpath);
  Printf("\x16\x08\x0a\x12%-23.23s",ar.msgname);
  Printf("\x16\x08\x0b\x12%-23.23s",ar.msgbar);
  Printf("\x16\x08\x0c\x12%d",ar.origin_aka);
  Printf("\x16\x08\x0d\x12%s",ar.origin);



  Printf("\x16\x08\x06\x15%s",ar.fileinfo);

  Printf("\x16\x08\x08\x3b%s",
         Priv_Level(ar.filepriv),
         ar.filelock ? "/" : blank_str,
         ar.filelock ? Keys(ar.filelock) : blank_str);

  Printf("\x16\x08\x09\x3b%-20.20s",ar.filepath);
  Printf("\x16\x08\x0a\x3b%-20.20s",ar.uppath);
  Printf("\x16\x08\x0b\x3b%-20.20s",ar.filebar);
  Printf("\x16\x08\x0c\x3b%-20.20s",ar.filepath);

  Printf("\x16\x08\x0f\x12%s",ar.menupath);
}

#endif

